Skip to content
Start here

Pull Queue Messages

client.Queues.Messages.Pull(ctx, queueID, params) (*MessagePullResponse, error)
POST/accounts/{account_id}/queues/{queue_id}/messages/pull

Pull a batch of messages from a Queue

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Queues WriteWorkers Scripts Write
ParametersExpand Collapse
queueID string

A Resource identifier.

maxLength32
params MessagePullParams
AccountID param.Field[string]Optional

Path param: A Resource identifier.

maxLength32
BatchSize param.Field[float64]Optional

Body param: The maximum number of messages to include in a batch.

VisibilityTimeoutMs param.Field[float64]Optional

Body param: The number of milliseconds that a message is exclusively leased. After the timeout, the message becomes available for another attempt.

ReturnsExpand Collapse
type MessagePullResponse struct{…}
MessageBacklogCount float64Optional

The number of unacknowledged messages in the queue.

Messages []MessagePullResponseMessageOptional
ID stringOptional
Attempts float64Optional
Body stringOptional
LeaseID stringOptional

An ID that represents an “in-flight” message that has been pulled from a Queue. You must hold on to this ID and use it to acknowledge this message.

Metadata unknownOptional
TimestampMs float64Optional
Metadata MessagePullResponseMetadataOptional
Metrics MessagePullResponseMetadataMetricsOptional

Best-effort metrics for the queue. Values may be approximate due to the distributed nature of queues.

BacklogBytes float64

The size in bytes of unacknowledged messages in the queue.

BacklogCount float64

The number of unacknowledged messages in the queue.

OldestMessageTimestampMs float64

Unix timestamp in milliseconds of the oldest unacknowledged message in the queue. Returns 0 if unknown.

Pull Queue Messages

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/queues"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.Queues.Messages.Pull(
    context.TODO(),
    "023e105f4ecef8ad9ca31a8372d0c353",
    queues.MessagePullParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.MessageBacklogCount)
}
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "message_backlog_count": 5,
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "lease_id": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "timestamp_ms": 1710950954154
      }
    ],
    "metadata": {
      "metrics": {
        "backlog_bytes": 1024,
        "backlog_count": 5,
        "oldest_message_timestamp_ms": 1710950954154
      }
    }
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "message_backlog_count": 5,
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "lease_id": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "timestamp_ms": 1710950954154
      }
    ],
    "metadata": {
      "metrics": {
        "backlog_bytes": 1024,
        "backlog_count": 5,
        "oldest_message_timestamp_ms": 1710950954154
      }
    }
  },
  "success": true
}